# coding=utf-8
from selenium import webdriver
from xml.dom import minidom
import re, time, sys

options = webdriver.ChromeOptions()
options.add_argument('--user-data-dir=C:/Users/user/AppData/Local/Google/Chrome/User Data')
driver = webdriver.Chrome(chrome_options = options)

def subscription(id):
	#Открываем URL канала
	url = u'https://www.youtube.com/channel/' + id[0]
	driver.get(url)
	#Находим кнопку подписки
	button = driver.find_element_by_xpath('//*[@id="c4-primary-header-contents"]/div/span/button[1]')
	
	#Если на кнопке нет атрибута 'data-is-subscribed="true"' - значит подписка не оформлена
	if button.get_attribute('data-is-subscribed') == None:
		#то кликаем на кнопку
		button.click()
		#Засыпаем на три секунды что-бы клик успел отработать, необходим при медленном интернете
		time.sleep(3)
		sys.stdout.write(" +++\r\n")
	else:
		#Иначе пишем:
		sys.stdout.write(" ---\r\n")

### Парсим XML файл подписок subscription_manager.xml берем здесь https://www.youtube.com/subscription_manager 
### в самом низу страницы, есть кнопка "Экспортировать подписки", кладем его рядом с этим скриптом
xmldoc = minidom.parse('subscription_manager.xml')
itemlist = xmldoc.getElementsByTagName('outline')
#Печатаем количество подписок
print(len(itemlist))
#Цикл обработки XML документа
for s in itemlist:
	try:
		feed_url = s.attributes['xmlUrl'].value
		#Находим ID канала регулярным выражением
		p = re.compile('channel_id=(.*)$')
		m = p.findall(feed_url)
		#Печатаем название канала
		sys.stdout.write(s.attributes['title'].value)
		#Вызываем функцию подписки
		subscription(m)
	except:
		pass

